<h2>Template: Básicos</h2>
<hr>

<div class="row">
    <div class="col">

        <form (ngSubmit)="guardar()" #miFormulario="ngForm" autocomplete="off">

            <!-- Campo de producto -->
            <div class="mb-3 row">
                <label class="col-sm-3 col-form-label">Producto</label>
                <div class="col-sm-9">
                    <input type="text" 
                           name="producto" 
                           [ngModel] = "initForm.producto"
                           class="form-control" 
                           placeholder="Nombre del producto" 
                           required
                           minlength="3">
                    <span *ngIf="nombreValido()" class="form-text text-danger">Debe de ser de 3 letras</span>
                </div>
            </div>

            <!-- Campo de precio -->
            <div class="mb-3 row">
                <label class="col-sm-3 col-form-label">Precio</label>
                <div class="col-sm-9">
                    <input type="number" 
                           name="precio" 
                           [ngModel] = "initForm.precio"
                           class="form-control" 
                           placeholder="Precio del producto" 
                           min="0" required>
                    <span *ngIf="precioValido()"    class="form-text text-danger">El Precio debe ser mayor a cero</span>
                    <span *ngIf="precioRequerido()" class="form-text text-danger">El Precio es requerido</span>
                </div>
            </div>

            <!-- Campo de existencias -->
            <div class="mb-3 row">
                <label class="col-sm-3 col-form-label">Existencias</label>
                <div class="col-sm-9">
                    <input type="number" 
                           name="existencia" 
                           [ngModel] = "initForm.existencia"
                           class="form-control" 
                           customMin 
                           [minimo]="0" 
                           placeholder="Existencia del producto" required>
                    <span *ngIf="existenciaValido()" class="form-text text-danger">Debe de ingresar una existencia</span>
                    <!-- <span class="form-text text-danger">Debe de ser de 3 letras</span> -->
                </div>
            </div>

            <div class="row">
                <div class="col">
                    <button type="submit" [disabled]="miFormulario.invalid" class="btn btn-primary float-end">Guardar</button>
                </div>
            </div>
            
            <div class="row">
                <div class="col">
                    <span>Valid</span>
                    <br>
                    <pre>{{ miFormulario.valid }}</pre>
                    <span>Pristine</span>
                    <br>
                    <pre>{{ miFormulario.pristine }}</pre>
                    <span>Touched</span>
                    <br>
                    <pre>{{ miFormulario.touched }}</pre>
                    <br>
                    <span>Value</span>
                    <br>
                    <pre>{{ miFormulario.value | json }}</pre>
                    
                    <span>CustomMin Directive</span>
                    <br>
                    <pre>{{ miFormulario.controls['existencia']?.errors | json }}</pre>
                </div>
            </div>
            
        </form>

    </div>
</div>
